<template>
  <div>
    <h2>Calculator</h2>
    <div class="calculatorContainer">
     
      <div>
        <p class="displayNumber">{{ currentNumber }}</p>
      </div>

      <br />

      <button
        v-for="number in numberKeys"
        @click="pushNumber(number)"
        :key="number"
      >
        {{ number }}
      </button>

      <br />

      <button @click="addNumber">+</button>
      <button @click="substractNumber">-</button>
      <button @click="multiplyNumber">*</button>
      <button @click="divideNumber">/</button>
      <button @click="clear">AC</button>
      <button @click="showResult">=</button>
    </div>
  </div>
</template>

<script>
const numberKeys = [1, 2, 3, 4, 5, 6, 7, 8, 9, 0];

export default {
  data() {
    return {
      lastNumber: 0,
      operation: "plus",
      currentNumberArray: [],
      numberKeys,
    };
  },

  computed: {
    currentNumber() {
      // We turn the array into a number so we don't need to convert
      // any other istance of the currentNumber
      return parseInt(this.currentNumberArray.join(""), 10) || 0;
    },
  },

  methods: {
    pushNumber(numberStr) {
      // Just add the last number to the array
      this.currentNumberArray.push(numberStr);
    },

    addNumber() {
      // Store the currentNumber in memory of the lastNumber
      this.operation = "plus";
      this.lastNumber = this.currentNumber;
      this.currentNumberArray = [];
    },

    substractNumber() {
      // Store the currentNumber in memory of the lastNumber
      this.operation = "minus";
      this.lastNumber = this.currentNumber;
      this.currentNumberArray = [];
    },

    multiplyNumber() {
      // Store the currentNumber in memory of the lastNumber
      this.operation = "multiply";
      this.lastNumber = this.currentNumber;
      this.currentNumberArray = [];
    },

    divideNumber() {
      // Store the currentNumber in memory of the lastNumber
      this.operation = "divide";
      this.lastNumber = this.currentNumber;
      this.currentNumberArray = [];
    },

    clear() {
      this.lastNumber = [];
      this.currentNumberArray = [];
    },

    showResult() {
      let result;
      if (this.operation == "plus") {
        result = this.lastNumber + this.currentNumber;
      } else if (this.operation == "minus") {
        result = this.lastNumber - this.currentNumber;
      } else if (this.operation == "multiply") {
        result = this.lastNumber * this.currentNumber;
      } else if (this.operation == "divide") {
        result = this.lastNumber / this.currentNumber;
      }

      this.currentNumberArray = [...String(result)];
      // Logic here has a lot of room for improvements
    },
  },
};
</script>

<style scoped>
.displayNumber {
  font-family: monospace;
  font-size: 1.6rem;
  border-radius: 4px;
  background-color: #ffffff;
  padding: 0.8rem;
}

.calculatorContainer {
  border: 0.2px solid;
  padding: 2rem;
  border-radius: 16px;
  box-shadow: 4px 8px;
  max-width: 400px;
  background-color: #e0d6fc;
}

button {
  border-radius: 80px;
  width: 50px;
  height: 50px;
  padding: 0.4rem 0.8rem;
  font-size: 1.6rem;
  background-color: #1f1f1f;
  color: #f3f3f3;
}
</style>